function [P, obw_a, obw_x, obw_y, obw_angle, dlo] = obvolute_area(seria, wysrodkowac, seria2)
% [P, obw_dl, obw_x, obw_y, obw_angle, dlo] = obvolute_area(seria, wysrodkowac,[seria2])
% Wylicza pole pow. obwoluty wyznaczonej przez sciezke
% Input data (either 1 variable `seria` 2-dimensional or 2 variables 1-dimensional (seria and seria2)
% Dane Wejciowe to albo 1 seria 2-wymiarowa (w zmiennej seria)
% albo dwie serie o rownej dlugosci (w zmiennych seria i seria2)
% assumes the center in (0,0), 
% zakada si ze srodek jest w pkcie 0,0
% Jeli rodek nie bdzie w rodku powierzchni, procedura da nieprawidowy wynik
%   obsuga tego bdu nie jest zaimplementowana
% zmienna 'wysrodkowac' domyslnie wynosi 1 i tak jest zalecane

% P     - obwolute area
% obw_x, obw_y - co-ordinates x i y of the obvolute points
% obw_a - distances of the obvolute from the center; odlegoci punktw obwoluty od srodka
% obw_angle - subsequent angles describing the obvolute direction; kolejne kty opisujace kierunek punktw obwoluty
% dlo - the length of the obvolute calculated over the points; dlugo obwoluty liczonej po tych punktach

step = 5; % stopnie
if nargin==1, wysrodkowac=1; end;

dl = length(seria);
if nargin <= 2
 s1 = seria(1:2:dl);
 s2 = seria(2:2:dl);
else
  s1 = seria;
  s2 = seria2;
end;
if length(s1)~=length(s2), disp(['Rozna dlugosc serii w funkcji pole_sc!!!']); end;

if (wysrodkowac)
   s1 = s1  -  median(s1);
   s2 = s2  -  median(s2);
end;
dl = length(s1);
angles = atan2(s2,s1)*180/pi;
%figure (4)
%plot(angles)
%pause
%hist(abs(angles(2:dl)- angles(1:dl-1)) ,600);
anglesint = floor(angles);
a = sqrt(s1.*s1 + s2.*s2);


%start
io =    0;
angleinit = -180;
while ((io==0) & (angleinit<0))
  ktore = (angles>=angleinit & angles<=angleinit+step) ;
  if sum(ktore)>0, io=1;
  else angleinit = angleinit+step;  
  end;   
end;   
ktoreind = find(angles>=angleinit & angles<=angleinit+step) ;

%size(angles)
[obw_a(1),obw_ind(1)] = max(a.*ktore);
obw_angle(1) = angles( obw_ind(1) );
obw_x(1) = s1(obw_ind(1));
obw_y(1) = s2(obw_ind(1));
nextexist=1;




while (nextexist)
   currind = obw_ind(io);
   currangle = angles(currind);
   nextaa = [-1,-1,-1];
   abest  = -1;
   if currind <dl  
      nextind = obw_ind(io)+1;
      anext     =     a(nextind);
      anglenext = angles(nextind);
      if anglenext>currangle & anglenext<currangle+10, 	nextaa(1)= anext;  end;
   end;
   
   if currind >1
      poprzind   = obw_ind(io)-1;
      apoprz     =      a(poprzind);
      anglepoprz = angles(poprzind);
      if anglepoprz>currangle & anglepoprz<currangle+10, 	nextaa(2)= apoprz; end;
   end;
   
   [nextaabetter, ind12] = max(nextaa);
   
   if nextaabetter>=0  % jeli istnieje kontynuacja cieki - szukamy w zakr do nast punktu
%      kont=1,
      if ind12==1, anglebetter=anglenext;  indbetter = nextind;
      else         anglebetter=anglepoprz; indbetter = poprzind; 
      end;
      ktore = (angles > currangle & angles <= anglebetter);
      if sum(ktore)>0,  [nextaa(3),max_ind] = max( a.*ktore ); end;
      
      [abest,ind123] = max(nextaa);
      if ind123==3, indbest = max_ind; end;
      if ind123==1, indbest = nextind; end;
      if ind123==2, indbest = poprzind; end;
      
            
   else % jei nie ma kontynuacji ciezki
 %     kont=0,
      nextangle = currangle+step;
      jestnext=0;
      while jestnext==0 & nextangle<180
        ktore = (angles > currangle & angles <= nextangle); 
        jestnext = sum(ktore);
        if jestnext==0, nextangle=nextangle+3; end;
       
      end;  
      if jestnext, [abest,indbest] = max( a.*ktore );
      else nextexist=0;
      end;   
%   pause   
   end;       % koniec warunku istnienia kontunuacji ciezki
   
   
   if nextexist
      io=io+1;
      obw_a  (io) = abest;
      obw_ind(io) = indbest;  
      obw_angle(io) = angles(indbest);
      obw_x(io) = s1(indbest);
      obw_y(io) = s2(indbest);
   end;   
  
%pause    
end;   %while   

% dodaj ostatni
io=io+1;
obw_a(io)=obw_a(1);
obw_x(io)=obw_x(1);
obw_y(io)=obw_y(1);
obw_angle(io)=obw_angle(1);
obw_ind(io)=obw_ind(1);

dlo=io;   


% wyliczenia koncowe
r1= (obw_x(2:dlo) - obw_x(1:dlo-1)).^2;
r2= (obw_y(2:dlo) - obw_y(1:dlo-1)).^2;
c = sqrt(r1 + r2);
p = (obw_a(1:dlo-1) + obw_a(2:dlo) + c) /2;
%PP = sqrt(p .* (p-obw_a(1:dlo-1)) .* (p-obw_a(2:dlo)) .* (p-c)) ;

P = sum( sqrt(p .* (p-obw_a(1:dlo-1)) .* (p-obw_a(2:dlo)) .* (p-c)) );

