function [Poleelipsymin,elipsa] = pole_obwol_vs_elipsy2a(obwoluta, szukanyprocent)
% calucates the area of the ellipse covering the 100-`percent` % of the obvolute
% Poleelipsymin - the returned area of the ellipse covering the obvolute;
% elipsa - the best ellipse being found
% w zmiennej x s optymalizowane parametry elipsy:
%x(1) promien x, x(2) = promien y, 
%x(3) srodek x,  x(4) = srodek y, 


MYOPTIONS    = FOPTIONS  ;         % ewentualnie zmienic foptions na duze litery !!
MYOPTIONS(14)=6000;
MYOPTIONS(1) = 0;
MYOPTIONS(2) = 0.000001;
MYOPTIONS(3) = 0.000001;

promienxpocz = (max(obwoluta(1,:)) - min(obwoluta(1,:))) /1.8;
promienypocz = (max(obwoluta(2,:)) - min(obwoluta(2,:)))/ 1.8;
srodekxpocz = (max(obwoluta(1,:)) - min(obwoluta(1,:))) /20;
srodekypocz = (max(obwoluta(2,:)) - min(obwoluta(2,:)))/ 20;



elipsapocz(1,:) = [promienxpocz, promienypocz,           0,           0];
elipsapocz(2,:) = [promienxpocz, promienypocz, srodekxpocz,           0];
elipsapocz(3,:) = [promienxpocz, promienypocz,-srodekxpocz,           0];
elipsapocz(4,:) = [promienxpocz, promienypocz,           0, srodekypocz];
elipsapocz(5,:) = [promienxpocz, promienypocz,           0,-srodekypocz];

elipsapocz(6,:) = [promienxpocz*0.9, promienypocz*0.9,           0,           0];
elipsapocz(7,:) = [promienxpocz*0.9, promienypocz*0.9, srodekxpocz,           0];
elipsapocz(8,:) = [promienxpocz*0.9, promienypocz*0.9,-srodekxpocz,           0];
elipsapocz(9,:) = [promienxpocz*0.9, promienypocz*0.9,           0, srodekypocz];
elipsapocz(10,:) = [promienxpocz*0.9, promienypocz*0.9,           0,-srodekypocz];

[ilpowt,tmp]= size(elipsapocz);
options = optimset('fminsearch');
%Display - Level of display [ off | iter | notify | final ]
options = optimset(options,'Display','off','MaxFunEvals',1000,'MaxIter',1000,'TolFun',0.001, 'TolX',0.001 );
for ii=1:ilpowt
   xx=sq(elipsapocz(ii,:));
   [x,opt] = fminsearch(@pole_obwol_vs_elipsy, xx, options,  obwoluta, szukanyprocent);
   opt;
   elipsy(ii,:) = x;
   Polaelipsy(ii)= x(1).* x(2) .* 3.1415;  yopttmp(ii) = opt;
end;
[Poleelipsymin,ind] = min(Polaelipsy);

ii=ilpowt+1;

xx=sq(elipsy(ind,:));
[x,opt] = fminsearch(@pole_obwol_vs_elipsy, xx, options, obwoluta, szukanyprocent);
opt;
elipsy(ii,:) = x;
Polaelipsy(ii)= x(1).* x(2) .* 3.1415;  yopttmp(ii) = opt;
[Poleelipsymin,ind] = min(Polaelipsy);


elipsa(1)=elipsy(ind,1) ;
elipsa(2)=elipsy(ind,2)  ;
elipsa(3)=elipsy(ind,3)  ;
elipsa(4)=elipsy(ind,4)  ;
