function [ iReal, iInt,yfit,dists ] = zerocrossings ( x, FHz, ktore,y )
%function [ iReal, iInt, yfit,dists ] = zerocrossings( x,FHz, ktore,y )
% iReal - indeksy  - liczby rzeczywiste wyliczone przez intepolacj -
% uwzgl. FHz
% iInt   -indeksy - liczby naturalne poprzedzajce  pkt przecicia ( nie
% uwzgl FHz
% ktore  - 0 - w obie strony, domyslnie
%         -1 z dod na uj.,   
%          1 - z uj. na dod.
% y - wektor, dla ktrego odczyta wartoci w indeksach pktw przecicia
% yfit - wartoci y 
% dists - wektor z odstpami pomidzy przeciciami  =diff(iReal)

yfit = NaN;
if nargin<2, FHz=1; end;
if nargin<3, ktore=0; end;
%[ ndim, iscol ] = ndims1( x );
%if iscol==0, x = tocolumn(x); end;
if ktore>=0, inds_np  = (x(2:end)>0 & x(1:end-1)<0); else inds_np = zeros(length(x)-1,1); end;
if ktore<=0, inds_pn =  (x(2:end)<0 & x(1:end-1)>0); else inds_pn = zeros(length(x)-1,1); end;
size(inds_pn);
size(inds_np);
inds_npn = inds_np | inds_pn;
iInt = find(inds_npn) ;
xpre = x(iInt);
xpost =x(iInt+1);
ratios = (-xpre)./(xpost-xpre);
iReal = (iInt+ratios) ./ FHz;
if nargin==4
 ypre  = y(iInt);
 ypost = y(iInt+1);
 yfit = ypre + ratios.*(ypost-ypre);
end;

dists = diff(iReal);


end

